{-------------------------------------------------------------------------------
Delphi Save And Restore
Copyright (C) 2009 ouiouioui contact@toutenvrac.org

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-------------------------------------------------------------------------------}
Unit Main;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, WinSkinStore, WinSkinData, Buttons, Utils, FileCtrl,
  JvAppStorage, JvAppIniStorage, JvComponentBase, JvFormMagnet, JvFormPlacement,
  MainFunctions, MainMsg, ZipMstr, Spin, ExtCtrls, dxGDIPlusClasses, Menus,
  ImgList, ShellApi;

Type
  TfmMain = Class(TForm)
    PageControl:             TPageControl;
    tsSave:                  TTabSheet;
    tsRestore:               TTabSheet;
    tsSettings:              TTabSheet;
    gbDirToSave:             TGroupBox;
    lbDirForSave:            TListBox;
    eDirForAddToSaveList:    TEdit;
    btSelectDirForSave:      TBitBtn;
    btDelDirDoesntExist:     TBitBtn;
    btReplaceDir:            TBitBtn;
    btAddDir:                TBitBtn;
    btDelDir:                TBitBtn;
    gbKeyToSave:             TGroupBox;
    lbKeyForSave:            TListBox;
    eKeyForAddToSaveList:    TEdit;
    btSelectKeyForSave:      TBitBtn;
    btDelKeyDoesntExist:     TBitBtn;
    btReplaceKey:            TBitBtn;
    btAddKey:                TBitBtn;
    btDelKey:                TBitBtn;
    eDirDestinationSave:     TEdit;
    eSelectDestinationSave:  TBitBtn;
    Label1:                  TLabel;
    btMakeSave:              TBitBtn;
    btRestoreSave:           TBitBtn;
    gbWhereSave:             TGroupBox;
    eDirWhereSave:           TEdit;
    btSelectWhereSave:       TBitBtn;
    gbListSave:              TGroupBox;
    lbSaveFound:             TListBox;
    gbSettingsRestore:       TGroupBox;
    cbCleanDirBeforeRestore: TCheckBox;
    cbEraseFileOnRestore:    TCheckBox;
    SkinData:                TSkinData;
    lVersion:                TLabel;
    Label3:                  TLabel;
    eNameForSave:            TEdit;
    JvFormMagnet:            TJvFormMagnet;
    JvFormStorage:           TJvFormStorage;
    JvAppIniFileStorage:     TJvAppIniFileStorage;
    lWait:                   TLabel;
    lCopy:                   TLabel;
    ZipMaster:               TZipMaster;
    Image1:                  TImage;
    cbCleanKeyBeforeRestore: TCheckBox;
    cbEraseKeyOnRestore:     TCheckBox;
    pmRestoreSave:           TPopupMenu;
    pmSaveDir:               TPopupMenu;
    pmmiDelAllDir:           TMenuItem;
    pmmiDelDir:              TMenuItem;
    pmSaveKey:               TPopupMenu;
    pmmiDelKey:              TMenuItem;
    pmmiDelAllKey:           TMenuItem;
    pmmiSaveRefresh:         TMenuItem;
    pmmiDelSelectedSave:     TMenuItem;
    pmmiDelAllSave:          TMenuItem;
    ImageList:               TImageList;
    gbSkin:                  TGroupBox;
    Label2:                  TLabel;
    cbSkinSelected:          TComboBox;
    gbSettingsSave:          TGroupBox;
    Label4:                  TLabel;
    CheckBox1:               TCheckBox;
    SpinEdit1:               TSpinEdit;
    Label6:                  TLabel;
    seCompressLevel:         TSpinEdit;
    gbUpdateProgram:         TGroupBox;
    btCheckUpdate:           TBitBtn;
    cbCheckUpdate:           TCheckBox;
    pStatus:                 TPanel;
    pbStatus:                TProgressBar;
    lStatus:                 TLabel;
    pbStatusTotal:           TProgressBar;
    Label5:                  TLabel;
    lLink:                   TLabel;
    btCancel:                TBitBtn;
    gbDivers:                TGroupBox;
    cbUseCorbeille:          TCheckBox;
    pWait:                   TPanel;
    Label7:                  TLabel;
    Procedure cbSkinSelectedChange(Sender: TObject);
    Procedure eSelectDestinationSaveClick(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure btSelectDirForSaveClick(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure btAddDirClick(Sender: TObject);
    Procedure btDelDirClick(Sender: TObject);
    Procedure btDelDirDoesntExistClick(Sender: TObject);
    Procedure btReplaceDirClick(Sender: TObject);
    Procedure btSelectWhereSaveClick(Sender: TObject);
    Procedure btDelKeyClick(Sender: TObject);
    Procedure btAddKeyClick(Sender: TObject);
    Procedure btReplaceKeyClick(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure btMakeSaveClick(Sender: TObject);
    Procedure btRestoreSaveClick(Sender: TObject);
    Procedure pmmiDelDirClick(Sender: TObject);
    Procedure pmmiDelAllDirClick(Sender: TObject);
    Procedure pmmiDelAllKeyClick(Sender: TObject);
    Procedure pmmiDelKeyClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure btDelKeyDoesntExistClick(Sender: TObject);
    Procedure seCompressLevelChange(Sender: TObject);
    Procedure pmmiSaveRefreshClick(Sender: TObject);
    Procedure tsRestoreShow(Sender: TObject);
    Procedure ZipMasterExtractSkipped(Sender: TObject; ForFile: String;
      SkipType: UnZipSkipTypes; ExtError: Integer);
    Procedure pmmiDelSelectedSaveClick(Sender: TObject);
    Procedure pmmiDelAllSaveClick(Sender: TObject);
    Procedure btCheckUpdateClick(Sender: TObject);
    Procedure ZipMasterTotalProgress(Sender: TObject; TotalSize: Int64;
      PerCent: Integer);
    Procedure lLinkMouseEnter(Sender: TObject);
    Procedure lLinkMouseLeave(Sender: TObject);
    Procedure lLinkClick(Sender: TObject);
    Procedure eDirForAddToSaveListKeyPress(Sender: TObject; Var Key: Char);
    Procedure eKeyForAddToSaveListKeyPress(Sender: TObject; Var Key: Char);
    Procedure btCancelClick(Sender: TObject);
    Procedure lbDirForSaveDblClick(Sender: TObject);
    Procedure lbKeyForSaveDblClick(Sender: TObject);
    Procedure cbUseCorbeilleClick(Sender: TObject);
    Procedure ZipMasterMessage(Sender: TObject; ErrCode: Integer;
      Message: String);
  Private
    ReadyToClose: Boolean;
    Procedure SetButtonsState;
    Procedure SetWaitState;
  End;

Var
  fmMain: TfmMain;

Implementation

{$R *.dfm}

Procedure SetlStatus(Msg: String);
Begin
  fmMain.lStatus.Caption := Msg;
  fmMain.lStatus.Repaint;
End;

Procedure SetpbStatusPosition(Position: Integer; Max: Integer = 0);
Begin
  If Max <> 0 Then
    fmMain.pbStatus.Max := Max;
  fmMain.pbStatus.Position := Position;
  fmMain.pbStatus.Repaint;
End;

Procedure SetpbStatusTotalPosition(Position: Integer; Max: Integer = 0);
Begin
  If Max <> 0 Then
    fmMain.pbStatusTotal.Max := Max;
  fmMain.pbStatusTotal.Position := Position;
  fmMain.pbStatusTotal.Repaint;
End;

//on change l'etat des divers objets selon leur tat actuel afin d'afficher ou non
//la progression d'une sauvegarde ou restauration
Procedure TfmMain.SetWaitState;
Begin
  ReadyToClose        := ReadyToClose = False;
  PageControl.Enabled := PageControl.Enabled = False;
  pWait.Visible       := pWait.Visible = False;
  pWait.BringToFront; {en cas oublie de remettre pWait en avant plan avant de compiler}
  Application.ProcessMessages;
End;

Procedure TfmMain.pmmiDelAllDirClick(Sender: TObject);
Begin
  If Application.MessageBox(PChar(MSGDelAll), PChar(MSGConfirm),
    MB_ICONQUESTION Or MB_YESNO Or MB_DEFBUTTON2) <> idYes Then
    Exit;
  SetWaitState;
  Try
    lbDirForSave.Items.Clear;
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.pmmiDelAllKeyClick(Sender: TObject);
Begin
  If Application.MessageBox(PChar(MSGDelAll), PChar(MSGConfirm),
    MB_ICONQUESTION Or MB_YESNO Or MB_DEFBUTTON2) <> idYes Then
    Exit;
  SetWaitState;
  Try
    lbKeyForSave.Items.Clear;
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.pmmiDelAllSaveClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    If MFDelAllSave(eDirWhereSave.Text) Then
      MFScanForSave(lbSaveFound, eDirWhereSave.Text, True);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.pmmiDelDirClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    lbDirForSave.Items.Delete(lbDirForSave.ItemIndex);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.pmmiDelKeyClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    lbKeyForSave.Items.Delete(lbKeyForSave.ItemIndex);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.pmmiDelSelectedSaveClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    If MFDelSaveSelected(lbSaveFound.ItemIndex, eDirWhereSave.Text) Then
      MFScanForSave(lbSaveFound, eDirWhereSave.Text, True);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.pmmiSaveRefreshClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    MFScanForSave(lbSaveFound, eDirWhereSave.Text);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.seCompressLevelChange(Sender: TObject);
Begin
  If TSpinEdit(Sender).Value < TSpinEdit(Sender).MinValue Then
    TSpinEdit(Sender).Value := 0;
End;

Procedure TfmMain.tsRestoreShow(Sender: TObject);
Begin
  MFScanForSave(lbSaveFound, eDirWhereSave.Text, True);
End;

Procedure TfmMain.ZipMasterExtractSkipped(Sender: TObject; ForFile: String;
  SkipType: UnZipSkipTypes; ExtError: Integer);
Begin
  //si on a autoris l'crasement et qu'un fichier ,ne l'a pas t on prvient l'utilisateur
  If cbEraseFileOnRestore.Checked Then
  Begin
    Application.MessageBox(PChar(Format(MSGCannotOverWriteFile, [ForFile])),
      PChar(MSGWarning),
      MB_OK Or MB_ICONWARNING);
  End;
End;

Procedure TfmMain.ZipMasterMessage(Sender: TObject; ErrCode: Integer;
  Message: String);
Begin
//-
End;

Procedure TfmMain.ZipMasterTotalProgress(Sender: TObject; TotalSize: Int64;
  PerCent: Integer);
Begin
  SetpbStatusPosition(PerCent, 100);
End;

Procedure TfmMain.eDirForAddToSaveListKeyPress(Sender: TObject; Var Key: Char);
Begin
  //si l'utilisateur appuie sur entrer dans la case on dclenche l'action ajouter
  If Key = #13 Then
  Begin
    Key := #0;
    btAddDirClick(Sender);
  End;
End;

Procedure TfmMain.eKeyForAddToSaveListKeyPress(Sender: TObject; Var Key: Char);
Begin
  //si l'utilisateur appuie sur entrer dans la case on dclenche l'action ajouter
  If Key = #13 Then
  Begin
    Key := #0;
    btAddKeyClick(Sender);
  End;
End;

Procedure TfmMain.eSelectDestinationSaveClick(Sender: TObject);
Begin
  MFSelectDirectory(MSGWherePutSave, eDirDestinationSave, [sdNewUI, sdNewFolder, sdShowEdit]);
End;

Procedure TfmMain.btSelectDirForSaveClick(Sender: TObject);
Begin
  MFSelectDirectory(MSGDirToSave, eDirForAddToSaveList);
End;

Procedure TfmMain.btSelectWhereSaveClick(Sender: TObject);
Begin
  If MFSelectDirectory(MSGDirOfSaveForRestore, eDirWhereSave) Then
    MFScanForSave(lbSaveFound, eDirWhereSave.Text);
End;

Procedure TfmMain.btDelKeyClick(Sender: TObject);
Begin
  MFDelSelectedItem(lbKeyForSave);
End;

//on change l'etat des divers objets selon leur tat actuel afin d'afficher ou non
//la progression d'une sauvegarde ou restauration
Procedure TfmMain.SetButtonsState;
Begin
  ReadyToClose        := ReadyToClose = False;
  PageControl.Enabled := PageControl.Enabled = False;
  lStatus.Caption     := '';
  pbStatus.Position   := 0;
  pStatus.Visible     := pStatus.Visible = False;
  btCancel.Enabled    := True;
  pStatus.BringToFront; {en cas oublie de remettre pstatus en avant plan avant de compiler}
  Application.ProcessMessages;
End;

Procedure TfmMain.btMakeSaveClick(Sender: TObject);
Begin
  SetButtonsState;
  Try
    //on envoie  l'unit les fonctions pour afficher la progression
    MFSetStatusProcedure(SetlStatus, SetpbStatusPosition, SetpbStatusTotalPosition);
    //on dmarre la procdure de sauvegarde
    MFStartSave(eNameForSave.Text, eDirDestinationSave.Text, lbDirForSave,
      lbKeyForSave, ZipMaster, seCompressLevel.Value);
  Finally
    SetButtonsState;
  End;
End;

Procedure TfmMain.btRestoreSaveClick(Sender: TObject);
Begin
  If lbSaveFound.ItemIndex = -1 Then
    Exit;

  If Application.MessageBox(PChar(Format(MSGRestoreThisSave, [lbSaveFound.Items[lbSaveFound.ItemIndex]])), PChar(MSGConfirm),
    MB_ICONQUESTION Or MB_YESNO Or MB_DEFBUTTON2) <> idYes Then
    Exit;
  //on affiche le message  l'utilisateur pour qu'ils patientent et on lui
  //enlve le droit de fermer le programme
  SetButtonsState;
  Try
    //on met  jour les rglages actuels pour l'opration de restauration
    MFSetRestoreSettings(cbCleanDirBeforeRestore.Checked, cbEraseFileOnRestore.Checked,
      cbCleanKeyBeforeRestore.Checked, cbEraseKeyOnRestore.Checked);
    //on envoie  l'unit les fonctions pour afficher la progression
    MFSetStatusProcedure(SetlStatus, SetpbStatusPosition, SetpbStatusTotalPosition);
    //on lance la restauration du fichier slectionn dans le dossier des sauvegardes choisies
    MFRestoreSave(lbSaveFound.ItemIndex, eDirWhereSave.Text, ZipMaster);
  Finally
    //on affiche la fentre normale et en autorise l'utilisateur a quitt le programme
    SetButtonsState;
  End;
End;

Procedure TfmMain.btCancelClick(Sender: TObject);
Begin
  TBitBtn(Sender).Enabled := False;
  //si on est sur la page de restauration des sauvegardes on demande  l'utilisateur
  //confirmation de l'arrt et on le prvient que les dossiers Effaces et dj restaurs
  //le resteront.
  If PageControl.ActivePageIndex = 1 Then
  Begin
    If Application.MessageBox('tes-vous srs de vouloir annuler la restauration? ' + sLineBreak +
      'Les dossiers dj effacs et/ou restaurs ne reviendront pas  leur tat initial.' + sLineBreak +
      'cela est fortement dconseill.', 'Confirmation',
      MB_ICONQUESTION Or MB_YESNO Or MB_DEFBUTTON2) <> idYes Then
    Begin
      TBitBtn(Sender).Enabled := True;
      Exit;
    End;
  End;
  CancelNow;
  ZipMaster.Cancel := True;
  lStatus.Caption  := 'Annulation en cours...';
End;

Procedure TfmMain.btCheckUpdateClick(Sender: TObject);
Begin
  MFCheckUpdate(cbSkinSelected.ItemIndex);
End;

Procedure TfmMain.btDelDirDoesntExistClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    MFDelEmptyDir(lbDirForSave);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.btReplaceDirClick(Sender: TObject);
Begin
  MFReplaceDirInListBox(eDirForAddToSaveList, lbDirForSave);
End;

Procedure TfmMain.btAddDirClick(Sender: TObject);
Begin
  MFAddDirInListBox(eDirForAddToSaveList, lbDirForSave);
End;

Procedure TfmMain.btDelDirClick(Sender: TObject);
Begin
  MFDelSelectedItem(lbDirForSave);
End;

Procedure TfmMain.btDelKeyDoesntExistClick(Sender: TObject);
Begin
  SetWaitState;
  Try
    MFDelEmptyKey(lbKeyForSave);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.btReplaceKeyClick(Sender: TObject);
Begin
  MFReplaceKeyInListBox(eKeyForAddToSaveList, lbKeyForSave);
End;

Procedure TfmMain.btAddKeyClick(Sender: TObject);
Begin
  MFAddKeyInListBox(eKeyForAddToSaveList, lbKeyForSave);
End;

Procedure TfmMain.cbSkinSelectedChange(Sender: TObject);
Begin
  SetWaitState;
  Try  //si l'utilisateur a choisi de ne pas utiliser de skin en active l'effet Glass
    If cbSkinSelected.ItemIndex = 0 Then
      fmMain.GlassFrame.Enabled := True
    Else
      fmMain.GlassFrame.Enabled := False;
  //on applique le changement de skins
    MFSetSkinSelected(SkinData, cbSkinSelected.ItemIndex);
  Finally
    SetWaitState;
  End;
End;

Procedure TfmMain.cbUseCorbeilleClick(Sender: TObject);
Begin
  SetUseCorbeille(TCheckBox(Sender).Checked);
End;

Procedure TfmMain.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
  JvFormStorage.SaveFormPlacement; //on enregistre les rglages
                                   //on vrifie si la dll zip est charg et si oui on la dcharge et on l'efface
  LoadDllZipNow(ZipMaster, False);
  MFFreeListOfSave;
End;

Procedure TfmMain.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
Begin
  CanClose := ReadyToClose;
End;

Procedure TfmMain.FormCreate(Sender: TObject);
Begin
  ReadyToClose := True;
  MFCreateListOfSave;
End;

Procedure TfmMain.FormShow(Sender: TObject);
Begin
  //on applique le numro de version du programme afin de l'afficher.
  lVersion.Caption             := ApplicationVersionBuild + ' ' + MSGBy + ' ouiouioui';
  //on met un chemin par dfaut de destination pour les sauvegardes
  //si le fichier ini n'existe pas c'est ce chemin qui sera affich
  eDirDestinationSave.Text     := ExtractFilePath(Application.ExeName) + 'Sauvegardes\';
  //on met un tab par dfaut si le fichier ini n'existe pas c'est ce tab qui sera affich
  PageControl.TabIndex         := 2;
  //on spcifie le nom du fichier ini qui doit tre nomm comme l'application
  JvAppIniFileStorage.FileName := ChangeFileExt(ExtractFileName(Application.ExeName), '.ini');
  JvFormStorage.RestoreFormPlacement; //on restore les rglages
  Application.ProcessMessages;
  cbSkinSelectedChange(cbSkinSelected); //on applique le skin slectionn
  SetUseCorbeille(cbUseCorbeille.Checked);//on applique les rglages afin que l'iunit mainfunctions sache comment proceder
  MFCheckUpdateAtStart(cbSkinSelected.ItemIndex, cbCheckUpdate.Checked); //on vrifie les mises  jour si autoris
End;

Procedure TfmMain.lbDirForSaveDblClick(Sender: TObject);
Begin
  If lbDirForSave.ItemIndex <> -1 Then
    eDirForAddToSaveList.Text := lbDirForSave.Items[lbDirForSave.ItemIndex];
End;

Procedure TfmMain.lbKeyForSaveDblClick(Sender: TObject);
Begin
  If lbKeyForSave.ItemIndex <> -1 Then
    eKeyForAddToSaveList.Text := lbKeyForSave.Items[lbKeyForSave.ItemIndex];
End;

Procedure TfmMain.lLinkClick(Sender: TObject);
Begin
  ShellExecute(handle, 'open', 'http://www.toutenvrac.org', '', '', SW_SHOWMAXIMIZED);
End;

Procedure TfmMain.lLinkMouseEnter(Sender: TObject);
Begin
  TLabel(Sender).Font.Color := clBtnText;
  TLabel(Sender).Cursor     := crHandPoint;
End;

Procedure TfmMain.lLinkMouseLeave(Sender: TObject);
Begin
  TLabel(Sender).Font.Color := clBtnShadow;
  TLabel(Sender).Cursor     := crDefault;
End;

End.

